package application;

import javafx.beans.binding.Bindings;
import javafx.beans.property.DoubleProperty;
import javafx.beans.property.SimpleDoubleProperty;

/**
 * 
 * @author Lorenz Schauer
 * 
 * Die Klasse Bank stellt das Model dar und besitzt 2 Properties fr Kontostand und Zinssatz
 *
 */
public class Bank{
	
	private DoubleProperty balance,interest;
	private double zinssatz = 0.025;
	
	
	// Konstruktor
	public Bank(double value){
		if(this.balance==null)
			this.balance = new SimpleDoubleProperty(value);
		else
			this.balance.set(value);
	}	
	
	// Wichtig fr Properties:
	public DoubleProperty balanceProperty(){
		
		if(this.balance==null)
			this.balance = new SimpleDoubleProperty(0);
		return this.balance;
	}
	
	// Wichtig fr Properties:
	public DoubleProperty interestProperty(){
		
		if(this.interest==null){
			this.interest = new SimpleDoubleProperty(0);
			
			// Wir binden die ZinsenProperty bei der Initialisierung gleich an das Produkt von Kontostand und Zinssatz, damit sich beim ndern des Kontostands
			// automatisch der Wert der Zinsen korrekt ndert.
			this.interest.bind(Bindings.multiply(zinssatz, this.balanceProperty()));
		}
		return this.interest;
	}
	
	public final void setBalance(double value){
		this.balance.set(value);
	}
	
	public final double getBalance(){
		if (this.balance == null)
			return 0.0;
		return this.balance.get();
	}
	
	public final double getInterest(){
		if (this.interest == null)
			return 0.0;
		return this.interest.get();
	}
	
	public void einzahlen(double betrag){
		this.balance.set(this.getBalance()+betrag);
	}
	
	public void auszahlen(double betrag){
		this.balance.set(this.getBalance()-betrag);
	}
	
	

}
